VERSION 5.00
Begin VB.Form FrmMap 
   Caption         =   "Map"
   ClientHeight    =   6690
   ClientLeft      =   1350
   ClientTop       =   1290
   ClientWidth     =   8550
   LinkTopic       =   "Form1"
   MouseIcon       =   "FrmMap.frx":0000
   ScaleHeight     =   6690
   ScaleWidth      =   8550
   Begin VB.CheckBox ChkAutoCenter 
      Caption         =   "Auto Center"
      Height          =   195
      Left            =   4320
      TabIndex        =   7
      Top             =   120
      Value           =   1  'Checked
      Width           =   1455
   End
   Begin VB.CommandButton BtnStoreLocation 
      Caption         =   "Store location"
      Height          =   375
      Left            =   1440
      TabIndex        =   6
      Top             =   0
      Width           =   1215
   End
   Begin VB.CommandButton BtnCalcPath 
      Caption         =   "Calculate Path"
      Height          =   375
      Left            =   2760
      TabIndex        =   5
      Top             =   0
      Width           =   1335
   End
   Begin VB.CommandButton BtnSetLocation 
      BackColor       =   &H80000008&
      Caption         =   "Set Location"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   0
      Width           =   1215
   End
   Begin VB.Timer Timer1 
      Interval        =   55
      Left            =   0
      Top             =   4200
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   100
      Left            =   120
      Max             =   920
      TabIndex        =   3
      Top             =   6360
      Width           =   8055
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   6135
      LargeChange     =   100
      Left            =   8280
      Max             =   450
      TabIndex        =   2
      Top             =   120
      Width           =   255
   End
   Begin VB.PictureBox Picture1 
      Height          =   5895
      Left            =   120
      MouseIcon       =   "FrmMap.frx":0152
      ScaleHeight     =   5835
      ScaleWidth      =   7995
      TabIndex        =   0
      Top             =   360
      Width           =   8055
      Begin VB.PictureBox Picture2 
         Height          =   735
         Left            =   0
         ScaleHeight     =   675
         ScaleWidth      =   675
         TabIndex        =   1
         Top             =   1320
         Width           =   735
      End
   End
End
Attribute VB_Name = "FrmMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim IneedREdraw As Boolean
Dim m_HScrolOld%, m_VScrolOld%

Dim MapImageHdr As BMPHeadderType

Dim m_DotsPerFootX#, m_DotsPerFootY#

Dim m_px%, m_py% 'picture X,Y of upper left corner
Dim SetMode%, m_MouseDownX%, m_MouseDownY%
Dim m_Mapx#, m_Mapy#, m_MapA# 'our map location in inches from lower left pointing at radian angle
'
Dim WithEvents m_EncoderLog As ClsEncoderLog
Attribute m_EncoderLog.VB_VarHelpID = -1
'

Private Sub Form_Load()
    
    Me.Left = GetSetting(g_RegName$, "Map", "Left", 1)
    Me.Top = GetSetting(g_RegName$, "Map", "Top", 1)
    Me.Width = GetSetting(g_RegName$, "Map", "Width", 7000)
    Me.Height = GetSetting(g_RegName$, "Map", "Height", 6000)
      
    Set m_EncoderLog = FrmMain.m_EncoderLog
    
    Dim MyClsIni As ClsINIFile
    Set MyClsIni = New ClsINIFile
    Call MyClsIni.FileLoad(App.Path & "/" & "Level25.ini")
    m_DotsPerFootX# = Val(MyClsIni.GetString("Image", "DotsPerFootX", "1"))
    m_DotsPerFootY# = Val(MyClsIni.GetString("Image", "DotsPerFootY", "1"))
    Set MyClsIni = Nothing
    g_MapImageDPIX# = m_DotsPerFootX# / 12
    g_MapImageDPIY# = m_DotsPerFootY# / 12
            
    Dim hdl%
    hdl% = FreeFile
    Open "Level25.BMP" For Binary Access Read As hdl%
    Get #hdl%, , MapImageHdr
    Close #hdl%
    'Picture1.AutoRedraw =
    Picture2.Visible = False
    Set Picture2.Picture = LoadPicture("Level25.BMP")
    
    m_HScrolOld% = 0
    m_VScrolOld% = 0
    
    HScroll1.Max = MapImageHdr.Width
    VScroll1.Max = MapImageHdr.Height
    VScroll1.Value = MapImageHdr.Height - 100
    
    SetMode% = 0
    Picture1.MousePointer = vbCustom
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '
    If Me.WindowState = vbNormal Then 'numbers are not valid if minimized
        Call SaveSetting(g_RegName$, "Map", "Left", Me.Left)
        Call SaveSetting(g_RegName$, "Map", "Top", Me.Top)
        Call SaveSetting(g_RegName$, "Map", "Width", Me.Width)
        Call SaveSetting(g_RegName$, "Map", "Height", Me.Height)
    End If
    Set m_EncoderLog = Nothing
End Sub
Private Sub Form_Resize()
    '
    If Me.Width > 500 And Me.Height > 1700 Then
        Picture1.Width = Me.Width - 600
        Picture1.Height = Me.Height - 1100
        
        VScroll1.Left = Me.Width - 400
        VScroll1.Height = Me.Height - 1100
        HScroll1.Top = Me.Height - 700
        HScroll1.Width = Me.Width - 600
    End If
End Sub

Private Sub ChkAutoCenter_Click()
    Call m_EncoderLog_Update
End Sub
Private Sub m_EncoderLog_Update()
    
    If SetMode% = 0 Then
        If ChkAutoCenter.Value Then
            m_HScrolOld% = ((m_EncoderLog.MapX * g_MapImageDPIX#))
            m_VScrolOld% = ((MapImageHdr.Height) - (m_EncoderLog.MapY * g_MapImageDPIY#))
            
            If m_HScrolOld% < 0 Then m_HScrolOld% = 0
            If m_HScrolOld% > HScroll1.Max Then m_HScrolOld% = HScroll1.Max
            If m_VScrolOld% < 0 Then m_VScrolOld% = 0
            If m_VScrolOld% > VScroll1.Max Then m_VScrolOld% = VScroll1.Max
            
            If m_HScrolOld% <> HScroll1.Value Then HScroll1.Value = m_HScrolOld%
            If m_VScrolOld% <> VScroll1.Value Then VScroll1.Value = m_VScrolOld%
            IneedREdraw = True
        End If
    End If
    
End Sub

Private Sub Picture1_Paint()
    IneedREdraw = False
    Dim p2X%, p2Y%
    
    Picture2.ScaleMode = vbPixels
    'p2X% = Picture2.Picture.Width 'grr twips anyway!
    'p2Y% = Picture2.Picture.Height
    
    Picture1.ScaleMode = vbPixels
    
    m_HScrolOld% = HScroll1.Value   'for timer redraw
    m_VScrolOld% = VScroll1.Value
    
    If SetMode% = 0 Then
        m_Mapx# = FrmMain.m_EncoderLog.MapX 'feet from left
        m_Mapy# = FrmMain.m_EncoderLog.MapY 'feet from bottom
        m_MapA# = FrmMain.m_EncoderLog.MapA 'radians
    End If

    p2X% = MapImageHdr.Width
    p2Y% = MapImageHdr.Height
    m_px% = (Picture1.ScaleWidth / 2) - (HScroll1.Value)
    m_py% = (Picture1.ScaleHeight / 2) - (VScroll1.Value)
    
    Call Picture1.Cls
    Call Picture1.PaintPicture(Picture2.Picture, m_px%, m_py%, p2X%, p2Y%)
        
    Call DrawCross((Picture1.ScaleWidth / 2), (Picture1.ScaleHeight / 2))
    
    Call FrmMain.m_EncoderLog.DrawPath(Picture1, m_px%, m_py% + p2Y%)
    
    'draw robot
    Dim RbotS As PointS 'screen cords
    RbotS.x = m_px% + (m_Mapx# * g_MapImageDPIX#)
    RbotS.y = (m_py% + p2Y%) - (m_Mapy# * g_MapImageDPIY#)
    Call DrawBot(RbotS)
End Sub

Private Sub DrawBot(S As PointS)
'rotate and place robot on picture1
'in x,y=screen cords
'm_MapA = angle is in radians
    Dim p1 As PointS, p2  As PointS, p3  As PointS, p4 As PointS
    Dim Sizex%, Sizey%, Asize%
    Sizex% = (g_BotWidth * g_MapImageDPIX#) / 2
    Sizey% = (g_BotLenght! * g_MapImageDPIY#) / 2
    Asize% = 96 * g_MapImageDPIY#
    
    p1.x = S.x - Sizex%
    p1.y = S.y - Sizey%
    p2.x = S.x + Sizex%
    p2.y = S.y - Sizey%
    p3.x = S.x + Sizex%
    p3.y = S.y + Sizey%
    p4.x = S.x - Sizex%
    p4.y = S.y + Sizey%
    
    Call drawRotatedLine(S, p1, p2) 'draw a box
    Call drawRotatedLine(S, p2, p3) '
    Call drawRotatedLine(S, p3, p4) '
    Call drawRotatedLine(S, p4, p1) '
    
    p1.x = S.x
    p1.y = S.y
    p2.x = S.x
    p2.y = S.y - (Asize%)
    p3.x = S.x - (Sizex% * 2)
    p3.y = p2.y + (Sizex% * 2)
    p4.x = S.x + (Sizex% * 2)
    p4.y = p3.y
    Call drawRotatedLine(S, p1, p2) '- draw arrow
    Call drawRotatedLine(S, p2, p3) '\
    Call drawRotatedLine(S, p2, p4) '/
    
End Sub
Private Sub drawRotatedLine(S As PointS, p1 As PointS, p2 As PointS)
    'draw and rotate a line around a center point.
    'm_mapA = angle in radians
    Dim s1 As PointS, s2 As PointS
    Dim SinMapA#, CosMapA#
           
    SinMapA# = Sin(-m_MapA)
    CosMapA# = Cos(-m_MapA)
        
    s1.x = S.x + (((p1.x - S.x) * CosMapA#) + ((p1.y - S.y) * SinMapA#))
    s1.y = S.y + (((p1.y - S.y) * CosMapA#) - ((p1.x - S.x) * SinMapA#))
    
    s2.x = S.x + (((p2.x - S.x) * CosMapA#) + ((p2.y - S.y) * SinMapA#))
    s2.y = S.y + (((p2.y - S.y) * CosMapA#) - ((p2.x - S.x) * SinMapA#))
        
    Picture1.Line (s1.x, s1.y)-(s2.x, s2.y), RGB(127, 0, 255)

End Sub

Private Sub DrawCross(ByVal x%, ByVal y%)
    Dim O%
    O% = m_DotsPerFootX#
    Picture1.Line (x% - O%, y%)-(x% + O% + 1, y%), RGB(127, 127, 127)
    Picture1.Line (x%, y% - O%)-(x%, y% + O% + 1), RGB(127, 127, 127)
End Sub
Private Sub Timer1_Timer()
    If Not (m_EncoderLog Is Nothing) Then
        If m_HScrolOld% <> HScroll1.Value Then IneedREdraw = True
        If m_VScrolOld% <> VScroll1.Value Then IneedREdraw = True
    
        If SetMode% = 0 Then
            If Abs(m_MapA# - m_EncoderLog.MapA) > 0.01 Then IneedREdraw = True
        End If
        
        If IneedREdraw Then Call Picture1_Paint
    
    End If 'encoder null?
End Sub

Private Sub BtnCalcPath_Click()
    SetMode% = 0
    Call FrmMain.m_EncoderLog.RecalculatePath
End Sub

Private Sub BtnSetLocation_Click()
    'BtnSetLocation.BackColor = RGB(255, 0, 0)
    SetMode% = 1
    Picture1.MousePointer = vbCrosshair
End Sub
Private Sub BtnSetLocation_KeyPress(KeyAscii As Integer)
    SetMode% = 0
    Picture1.MousePointer = vbCustom
    IneedREdraw = True
End Sub

Private Sub Picture1_KeyPress(KeyAscii As Integer)
    SetMode% = 0
    Picture1.MousePointer = vbCustom
    IneedREdraw = True
End Sub
Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    m_MouseDownX% = x
    m_MouseDownY% = y
    If SetMode% >= 1 Then
        SetMode% = 2
        m_Mapx# = (x - m_px%) / g_MapImageDPIX#
        m_Mapy# = (MapImageHdr.Height - (y - m_py%)) / g_MapImageDPIY#
        IneedREdraw = True
    End If
End Sub
Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If SetMode% = 2 Then
        If (m_MouseDownX% <> x) Or (m_MouseDownY% <> y) Then
        
            Dim DeltaX%, DeltaY%
            DeltaX% = x - m_MouseDownX%
            DeltaY% = -(y - m_MouseDownY%)
            If Abs(DeltaX%) > Abs(DeltaY%) Then
                If DeltaX% > 0 Then
                    m_MapA# = (3.141592654 / 2) - Atn(DeltaY% / DeltaX%)
                Else
                    m_MapA# = ((3.141592654 * 1.5) + Atn(DeltaY% / Abs(DeltaX%)))
                End If
            Else
                If DeltaY% > 0 Then
                    m_MapA# = Atn(DeltaX% / DeltaY%)
                Else
                    m_MapA# = (3.141592654) - Atn(DeltaX% / Abs(DeltaY%))
                End If
            End If
            
            IneedREdraw = True
        End If
    End If
    If SetMode% = 0 And Button = 1 Then
        m_HScrolOld% = m_HScrolOld% - (x - m_MouseDownX%)
        m_VScrolOld% = m_VScrolOld% - (y - m_MouseDownY%)
        m_MouseDownX% = x
        m_MouseDownY% = y
        
        If m_HScrolOld% < 0 Then m_HScrolOld% = 0
        If m_HScrolOld% > HScroll1.Max Then m_HScrolOld% = HScroll1.Max
        If m_VScrolOld% < 0 Then m_VScrolOld% = 0
        If m_VScrolOld% > VScroll1.Max Then m_VScrolOld% = VScroll1.Max
        
        If m_HScrolOld% <> HScroll1.Value Then HScroll1.Value = m_HScrolOld%
        If m_VScrolOld% <> VScroll1.Value Then VScroll1.Value = m_VScrolOld%
        IneedREdraw = True
    End If
    
    
End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If SetMode% > 0 Then
        SetMode% = 1
    End If
End Sub
Private Sub BtnStoreLocation_Click()
    '
    If SetMode% >= 1 Then
        If Not (m_EncoderLog Is Nothing) Then
            Call m_EncoderLog.AddEncoderWayPoint(m_Mapx#, m_Mapy#, m_MapA#)
        End If
    End If
    
    SetMode% = 0
    Picture1.MousePointer = vbCustom
    IneedREdraw = True
End Sub


