Attribute VB_Name = "ModSerialPkt"
Option Explicit
'
Public g_RegName$   'registry location

'structures and constants for ClsSerialPKT
    Public Type DeviceInfoType    'cached data about device
        Found As Boolean        'true if found during ID setup
        StatusCode As Integer   'last Set Status code
        CustomStatusCode As Integer   'Custom Status code requested
        
        StatusByte As Integer       '
        StatusPos As Long           '   1: 4 bytes Current Position (signed)
        StatusAD As Integer         '   2: 1 byte  A/D (R/C input) value (unsigned)
        StatusVel As Long           '   4: 2 bytes Current velocity (signed)
        StatusAux As Integer        '   8: 1 byte  Auxiliary status byte
        StatusHome As Long          '&h10: 4 bytes    Home position (signed)
        StatusType As Long          '&h20: 2 bytes    Device type
        
        LastHeardFrom As Integer 'for status scheduling
    End Type
    
    Public Type SocketInfoType
        SOpen As Boolean        'true if socket handle is in use
        Active As Boolean       'true if active
        TimeOut As Boolean      'true if no response
        DeviceID As Integer     'Device ID number
        StatusCode As Integer   'requested status data. (OR'd with other sockets)
        
        PktCommand As Integer   'for packet retrys
        PktData(256) As Byte
        PktDataLen As Integer
           
    End Type


'FrmMap BMP file
Public Type BMPHeadderType
    Ident As String * 2
    FileSize As Long
    Reserved As Long
    BitmapOffset As Long
    HeaderSize As Long
    Width As Long
    Height As Long
    Planes As Integer
    BPP As Integer     'Bits Per Pixel
    Compression As Long
    BitmapDataSize As Long
    HResolution As Long 'in pixels per meter.
    VResolution As Long 'in pixels per meter.
    Colors As Long      'number of palete entrys
    ImportantColors As Long
End Type
    
'ClsEncoderLog
'public type
    
    
