VERSION 5.00
Object = "{BDC217C8-ED16-11CD-956C-0000C04E4C0A}#1.1#0"; "TABCTL32.OCX"
Begin VB.Form FrmDiag 
   Caption         =   "Diagnostics"
   ClientHeight    =   5505
   ClientLeft      =   3285
   ClientTop       =   1965
   ClientWidth     =   6765
   LinkTopic       =   "Form1"
   ScaleHeight     =   5505
   ScaleWidth      =   6765
   Begin VB.CommandButton CmdGetStatus 
      Caption         =   "Get Status"
      Height          =   375
      Left            =   1200
      TabIndex        =   4
      Top             =   5040
      Width           =   975
   End
   Begin VB.CommandButton CmdInit 
      Caption         =   "Init Port"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   5040
      Width           =   855
   End
   Begin TabDlg.SSTab SSTab1 
      Height          =   4815
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6495
      _ExtentX        =   11456
      _ExtentY        =   8493
      _Version        =   393216
      Tab             =   2
      TabHeight       =   520
      TabCaption(0)   =   "Hex Editor"
      TabPicture(0)   =   "FrmDiag.frx":0000
      Tab(0).ControlEnabled=   0   'False
      Tab(0).Control(0)=   "Label1"
      Tab(0).Control(1)=   "CboDeviceID"
      Tab(0).ControlCount=   2
      TabCaption(1)   =   "Device info"
      TabPicture(1)   =   "FrmDiag.frx":001C
      Tab(1).ControlEnabled=   0   'False
      Tab(1).Control(0)=   "TxtDeviceList"
      Tab(1).ControlCount=   1
      TabCaption(2)   =   "Packet Sniffer"
      TabPicture(2)   =   "FrmDiag.frx":0038
      Tab(2).ControlEnabled=   -1  'True
      Tab(2).Control(0)=   "TxtPktSniffer"
      Tab(2).Control(0).Enabled=   0   'False
      Tab(2).ControlCount=   1
      Begin VB.ComboBox CboDeviceID 
         Height          =   315
         ItemData        =   "FrmDiag.frx":0054
         Left            =   -74160
         List            =   "FrmDiag.frx":0056
         TabIndex        =   5
         Text            =   "1"
         Top             =   480
         Width           =   735
      End
      Begin VB.TextBox TxtDeviceList 
         Height          =   3975
         Left            =   -74760
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   2
         Top             =   600
         Width           =   5895
      End
      Begin VB.TextBox TxtPktSniffer 
         Height          =   3255
         Left            =   240
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   1
         Top             =   1320
         Width           =   6015
      End
      Begin VB.Label Label1 
         Caption         =   "Device"
         Height          =   255
         Left            =   -74760
         TabIndex        =   6
         Top             =   480
         Width           =   615
      End
   End
End
Attribute VB_Name = "FrmDiag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents MySerialPkt As ClsSerialPkt
Attribute MySerialPkt.VB_VarHelpID = -1

Dim m_PktTxt As String

Dim IamBusy%

Dim PktSniffClearCounter%

Private Sub Form_Load()
'
    Set MySerialPkt = FrmMain.MySerialPkt
    
    Call MySerialPkt_DeviceListUpdate

End Sub

Private Sub Form_Unload(Cancel As Integer)
'
    Set MySerialPkt = Nothing

End Sub

Private Sub MySerialPkt_DataReceive(newData() As Byte, DataLen As Integer)
    '
    Dim i%
    If SSTab1.Tab = 2 Then
        If PktSniffClearCounter% > 2 Then
            m_PktTxt = ""
        Else
            m_PktTxt = TxtPktSniffer.Text
        End If
        m_PktTxt = m_PktTxt + "> "
        For i% = 0 To DataLen - 1
            m_PktTxt = m_PktTxt + Right$("00" + Hex$(newData(i)), 2) + " "
        Next i%
        m_PktTxt = m_PktTxt + vbNewLine
        TxtPktSniffer.Text = m_PktTxt
        PktSniffClearCounter% = 0
    End If
End Sub

Private Sub MySerialPkt_DeviceListUpdate()
    Dim i%, d$, DevT$
    d$ = ""
    DevT$ = CboDeviceID.Text
    Call CboDeviceID.Clear
    For i = 0 To 127
        If MySerialPkt.GetDeviceInfoFound(i) Then
            d$ = d$ + ">" + Right$("  " + Str$(i), 3) + vbNewLine
            Call CboDeviceID.AddItem(Right$("  " + Str$(i), 3))
        End If
    Next
    CboDeviceID.Text = DevT$
    TxtDeviceList.Text = d$

End Sub

Private Sub CmdInit_Click()
    If IamBusy% Then Exit Sub
    IamBusy% = True
    TxtPktSniffer.Text = ""
    Call MySerialPkt.PortInit(MySerialPkt.CommPort)
    TxtPktSniffer.Text = TxtPktSniffer.Text + "done"
    IamBusy% = False
End Sub
Private Sub CmdGetStatus_Click()
    If IamBusy% Then Exit Sub
    IamBusy% = True
    
    Dim ASocket As Integer, i%
    ASocket = MySerialPkt.SocketOpen(0)
    TxtPktSniffer.Text = ""
    For i = 1 To 2
        TxtPktSniffer.Text = TxtPktSniffer.Text + "Start" + Str$(i%)
        MySerialPkt.SocketDeviceID(ASocket) = i
        Call MySerialPkt.CmdGetCustomStatus(ASocket, &H3F)
        Call MySerialPkt.SocketWaitComplete(ASocket)
        TxtPktSniffer.Text = TxtPktSniffer.Text + "done" + vbNewLine
    Next
    Call MySerialPkt.SocketClose(ASocket)
    IamBusy% = False
End Sub

Private Sub MySerialPkt_StatusReceived(DeviceID As Integer, StatusCode As Integer, newData() As Byte, DataLen As Integer)
    Dim i%, d$, DevT$
    d$ = ""
    DevT$ = CboDeviceID.Text
    Call CboDeviceID.Clear
    For i = 0 To 127
        If MySerialPkt.GetDeviceInfoFound(i) Then
            d$ = d$ & ">" & Right$("  " + Str$(i), 3)
            d$ = d$ & " Sb=" & Right$("00" & Hex$(MySerialPkt.GetDeviceInfoByNum(i, 0)), 2)
            d$ = d$ & " Pos=" & Right$("00000000" & Hex$(MySerialPkt.GetDeviceInfoByNum(i, 1)), 8)
            d$ = d$ & vbNewLine
            Call CboDeviceID.AddItem(Right$("  " + Str$(i), 3))
        End If
    Next
    CboDeviceID.Text = DevT$
    TxtDeviceList.Text = d$
        
End Sub

Private Sub MySerialPkt_Timer55()
    PktSniffClearCounter% = PktSniffClearCounter% + 1
    If PktSniffClearCounter% > 1000 Then PktSniffClearCounter% = 1000
End Sub
