Attribute VB_Name = "Modglobal"
Option Explicit
'
    Public g_RegName$       'registry location
    Public g_BotWidth!      'width in inches
    Public g_BotLenght!     'lenght in inches
    Public g_BotHeight!     'height in inches
    Public g_BotEncoderR#   'Right Encoder counts per inch
    Public g_BotEncoderL#   'Left Encoder counts per inch
    Public g_BotWheelDistance#   'for Encoder use
    
    Public g_MapImageDPIX#  'image DPI for path calculation
    Public g_MapImageDPIY#  'image DPI for path calculation
    
Public Type PointS
    x As Integer
    y As Integer
End Type
Public Type PointL
    x As Long
    y As Long
End Type

'structures and constants for ClsSerialPKT
    Public Type DeviceInfoType    'cached data about device
        Found As Boolean        'true if found during ID setup
        StatusCode As Integer   'last Set Status code
        CustomStatusCode As Integer   'Custom Status code requested
        
        StatusByte As Integer       '
        StatusPos As Long           '   1: 4 bytes Current Position (signed)
        StatusAD As Integer         '   2: 1 byte  A/D (R/C input) value (unsigned)
        StatusVel As Long           '   4: 2 bytes Current velocity (signed)
        StatusAux As Integer        '   8: 1 byte  Auxiliary status byte
        StatusHome As Long          '&h10: 4 bytes    Home position (signed)
        StatusType As Long          '&h20: 2 bytes    Device type
        
        LastHeardFrom As Integer 'for status scheduling
    End Type
    
    Public Type SocketInfoType
        SOpen As Boolean        'true if socket handle is in use
        Active As Boolean       'true if active
        TimeOut As Boolean      'true if no response
        DeviceID As Integer     'Device ID number
        StatusCode As Integer   'requested status data. (OR'd with other sockets)
        
        PktCommand As Integer   'for packet retrys
        PktData(256) As Byte
        PktDataLen As Integer
           
    End Type


'FrmMap BMP file
Public Type BMPHeadderType
    Ident As String * 2
    FileSize As Long
    reserved As Long
    BitmapOffset As Long
    HeaderSize As Long
    Width As Long
    Height As Long
    Planes As Integer
    BPP As Integer     'Bits Per Pixel
    Compression As Long
    BitmapDataSize As Long
    HResolution As Long 'in pixels per meter.
    VResolution As Long 'in pixels per meter.
    Colors As Long      'number of palete entrys
    ImportantColors As Long
End Type
    
'ClsEncoderLog
Public Type EncoderByteLogType
    bR As Byte           'signed -127 to +127 (-128 means next record is.. )
    bL As Byte           'signed -127 to +127 (0=FullLog,1=WayPoint)
End Type
Public Type EncoderFulLogType
    lR As Long          '4 signed long delta
    lL As Long          '4
End Type
Public Type EncoderWPLogType 'waypoint
    flags As Long       '4 reserved
    wp As Long          '4 where we are
    MapX As Single      '4 in inches
    MapY As Single      '4 in inches
    MapA As Single      '4 in radians
    TNow As Date        '8
End Type

Public Type EncoderHeadderType '128
    FileIdent As String * 4 '"ELOG"
    Version As Long     '4 =0, 1=map pos in pixels
    flags As Long       '4 reserved
    wp As Long          '4 Last wp visited
    MapX As Single      '4 in inches
    MapY As Single      '4 in inches
    MapA As Single      '4 in radians
    TNow As Date        '8
    WayPoints As Long   '4
    reserved As String * 88
End Type

